package com.izenpe.zain.cliente.pdf;

import org.apache.axis.encoding.Base64;

import com.izenpe.zain.client.ZainConfig;
import com.izenpe.zain.cliente.util.Constantes;
import com.izenpe.zain.cliente.util.Propiedades;
import com.izenpe.zain.cliente.util.ZainUtil;
import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartSignRequest;
import com.safelayer.trustedx.client.smartwrapper.SmartSignResponse;

public class GeneracionFirmaPDF_TS {
	// Nombre del fichero a utilizar para la Generación de la firma PDF.
	private static final String fileName = "PruebaPDF.pdf";

	public static void main(String[] args) {
		try {
			ZainConfig.setCurrent(Propiedades.ZAIN_CONFIG);
			/*
			 * Se crea la petición a través de la URL definida en ZAIN_ENDPOINT.
			 */
			SmartSignRequest smartSignReq = new SmartSignRequest(Propiedades.ZAIN_ENDPOINT);

			// Se establece el perfil de firma PDF en la petición de Generación
			// de firma.
			smartSignReq.setProfile(Constants.Profile.PDF);

			/*
			 * Se establece el idioma de la petición en español. 2
			 * posibilidades: 1. Español: 'es' 2. Inglés: 'en'
			 */
			smartSignReq.setLanguage("es");

			/*
			 * Cuando este elemento se omite, la firma no incluye el atributo
			 * signingcertificate. Esto es, el formato de la firma no puede
			 * considerarse equivalente al formato PKCS #7 de una firma
			 * CAdES-BES (y por tanto es una firma NoAdES).
			 */
			smartSignReq.setSignatureFormat(Constants.SignatureFormat.ES_T);

			// Certificado con el que realizar la firma.
			smartSignReq.setKeySubjectName(Propiedades.ZAIN_SIGNER);
			

			// Datos a firmar.
			smartSignReq.setInputPdfBase64Data(Base64.encode(ZainUtil.readBinaryFile("data/input/" + fileName)));

			// Envío de la petición.
			SmartSignResponse smartSignResp = smartSignReq.send();

			/*
			 * Se comprueba la validez de la respuesta y se escribe la respuesta
			 * de Generación de firma PDF en un fichero en disco.
			 */
			if (Constantes.RMAJOR_SUCCESS.equals((smartSignResp.getResultMajor()))
					&& smartSignResp.getResultMinor() == null) {
				String docPDF = smartSignResp.getDocumentWithSignaturePdf();
				byte[] data = Base64.decode(docPDF);
				String destFilename = "data/output/" + fileName.substring(0, fileName.lastIndexOf(".")) + "SignedTS.pdf";
				ZainUtil.writeBinaryFile(destFilename, data);
				System.out.println("La firma ha sido generada con éxito");
			} else {
				System.out.println("Error en la Generación de Firma:" + smartSignResp.getResultMessage());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}